//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup Tool "FUNSSEL" developed for the 
// Simulator League of the RoboCup 2001 competition
//
// Copyright (C) 1998, 1999, 2000, 2001 Team Members 
// of the Mainz Rolling Brains RoboCup Team 
//
// This program is published under the terms of the GNU General Public 
// License as published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////
//
// FLogWindow.h - Implements a simple logfile window using a QListView
//
// $Id: FLogWindow.h,v 1.12 2002/04/08 15:52:19 cs Exp $
//
////////////////////////////////////////////////////////////////////////

#ifndef FLOGWINDOW_H
#define FLOGWINDOW_H

#include <qlistview.h>
#include <qpopupmenu.h>
#include <qpixmap.h>

#include "FColors.h"
#include "Config.h"

#if (QT_VERSION >= 200)
#define QT2
#endif

class FLogWindow : public QListView
{
  Q_OBJECT

public:
  FLogWindow(QWidget * parent = 0, const char * name = 0);
  ~FLogWindow();
  
  // returns the state of the "clear before new step" flag
  bool clearStep()
  { return contextMenu->isItemChecked(1); }

public slots:
  void addLine( const int time, const int color, const int plNum,
		const char *msg);
  void addLine( const int time, const char *msg)
  { addLine( time, -1, -1, msg ); }

  void clearList() 
  { clear(); }

  void toggleClearMode()
  { contextMenu->setItemChecked(1, !clearStep()); }

signals:
  void closedWindow();

protected:
  // some strange renaming in QT2 ...
#ifdef QT2
  virtual void contentsMouseReleaseEvent ( QMouseEvent * );
#else
  virtual void mouseReleaseEvent ( QMouseEvent * );
#endif

  virtual void closeEvent( QCloseEvent * e )
  { e->accept(); emit closedWindow(); }
  
private:
  QPopupMenu *contextMenu;
  QPixmap    **entryIcons;
  const int  maxEntryIcons;
};

#endif
