//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup Tool "FUNSSEL" developed for the 
// Simulator League of the RoboCup 2001 competition
//
// Copyright (C) 1998, 1999, 2000, 2001 Team Members 
// of the Mainz Rolling Brains RoboCup Team 
//
// This program is published under the terms of the GNU General Public 
// License as published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////
//
// FPlayerWin.h - Window for setting players to certain positions 
//
// $Id: FPlayerWin.h,v 1.2 2001/09/11 10:08:37 goetz Exp $
//
////////////////////////////////////////////////////////////////////////

#ifndef FPLAYERWIN_H
#define FPLAYERWIN_H

#include <qwidget.h>
#include <qcombobox.h>
#include <qlineedit.h>
#include <qvalidator.h>
#include <qpushbutton.h>
#include <qlabel.h>

#include "coordinates.h"

class FPlayerWin : public QWidget
{
  Q_OBJECT

public:
  FPlayerWin( QWidget * parent=0, const char * name=0 );
  ~FPlayerWin() {}

signals:
  void setPlayerExec( bool sideLeft, int num, Vector2d pos, Angle ang);
  void closedWindow();

public slots:
  void setPosn( Vector2d pos );

protected slots:
  void setButtonPressed();
  void closeButtonPressed()
  { hide(); emit closedWindow(); }
  void resetButtonPressed();

protected:
  virtual void closeEvent ( QCloseEvent * e )
  { e->accept(); emit closedWindow(); }
  virtual void resizeEvent ( QResizeEvent * );

private:
  QComboBox *sideSel;
  QComboBox *plnum;
  QLineEdit *xpos;
  QLineEdit *ypos;
  QLineEdit *ang;
  QPushButton *setButton;
  QPushButton *resetButton;
  QPushButton *closeButton;
  QLabel    *xlabel;
  QLabel    *ylabel;
  QLabel    *anglabel;
};

#endif
