//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup Tool "FUNSSEL" developed for the 
// Simulator League of the RoboCup 2001 competition
//
// Copyright (C) 1998, 1999, 2000, 2001 Team Members 
// of the Mainz Rolling Brains RoboCup Team 
//
// This program is published under the terms of the GNU General Public 
// License as published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

#ifndef FUNSSELIO_H
#define FUNSSELIO_H
#include "SoccerMessage.h"
#include "Socket.h"

class FunsselIO {
  int curtime;
  int srvtime;
  SoccerMessage smsg;

  Socket sock;
public:
  FunsselIO(int port, const char *host);

  enum Result {
    NoMsg         = 0,
    SoccerMsg     = 1,
    MsgEol        = 2,
    ServerStarted = 3,
    WindOk        = 4,
    WindFailed    = 5,
    MsgDropped    = 6,
    NewSrvTime    = 7
  };

  void wind(int);
  void windRel(int);
  void maxRunTime(int);
  void startServer();
  void quit();
  void poll();
  void init();
  void sendMsg( const SoccerMessage & );

  Result getNextMsg();

  int currentTime() const { return curtime; }
  int serverTime()  const { return srvtime; }
  const SoccerMessage &currentMsg() const { return smsg; }
};

#endif
