//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup Tool "FUNSSEL" developed for the 
// Simulator League of the RoboCup 2001 competition
//
// Copyright (C) 1998, 1999, 2000, 2001 Team Members 
// of the Mainz Rolling Brains RoboCup Team 
//
// This program is published under the terms of the GNU General Public 
// License as published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

#ifndef SOCCERMSG_H
#define SOCCERMSG_H
#include <string>

enum SoccerActor {
  NoOne      = 0,
  PlayerL_1  = 1,
  PlayerL_2  = 2,
  PlayerL_3  = 3,
  PlayerL_4  = 4,
  PlayerL_5  = 5,
  PlayerL_6  = 6,
  PlayerL_7  = 7,
  PlayerL_8  = 8,
  PlayerL_9  = 9,
  PlayerL_10 = 10,
  PlayerL_11 = 11,
  CoachL     = 12,
  PlayerR_1  = 13,
  PlayerR_2  = 14,
  PlayerR_3  = 15,
  PlayerR_4  = 16,
  PlayerR_5  = 17,
  PlayerR_6  = 18,
  PlayerR_7  = 19,
  PlayerR_8  = 20,
  PlayerR_9  = 21,
  PlayerR_10 = 22,
  PlayerR_11 = 23,
  CoachR     = 24,
  OfflineCoach   = 25,
  SoccerServer   = 26,
  SoccerMonitor  = 27,
  FunsselMonitor = 28,
  NumberSActors  = 29
};

class SoccerMessage {
public:
  string message;
  int    time;
  int    durtn;

  SoccerActor sender;
  SoccerActor recver;

public:
  SoccerMessage(int time, const string &message,
		SoccerActor sender, SoccerActor recver,
		int duration = 1);
  SoccerMessage();

  operator const string &() const { return message; }
  

  bool          isValid()   const { return (sender != NoOne); }
  int           getLength() const { return message.length(); }

  int           getTime() const { return time; }

  static const SoccerMessage emptyMessage;
};

#endif
