//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup agents developed for the Simulator 
// League of the RoboCup 2001 competition
//
// Copyright (C) 1998, 1999, 2000, 2001 Team Members 
// of the Mainz Rolling Brains RoboCup Team 
//
// This program is published under the terms of the GNU General Public
// License as published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

// -*- c++ -*- /////////////////////////////////////////////////
//
// $Id: mastercontrol.h,v 1.19 2002/06/09 12:40:26 cs Exp $
//
// 
//
////////////////////////////////////////////////////////////////


#include <unistd.h>
#include "player.h"
#include "snapshot.h"


#include "standardsituationmodule.h"
#include "passmodule.h"
#include "passeval.h"
#include "ballhandlingmodule.h"
#include "goalshotmodule.h"
#include "goalshoteval.h"
#include "PositionModule.h"

class MasterControl : public Player {
public:
  MasterControl(const char* team, bool goalie, const char *host, int port,
		bool log, int recn, const char *configfile, bool FUNSSELmode,
		int clangMinVer, int clangMaxVer);
  ~MasterControl();

  virtual void act();
  
private:

  bool communicateTackle;   // for the use of emergency channel after tackling

  void sendAudioMsg(const Snapshot *);

  StandardSituationModule *standard;
  PassModule              *pass;
  PassEval                *passeval;
  BallHandlingModule      *ballhandling;
  GoalShotModule          *goalshot;
  GoalShotEval            *goaleval;
  TacticalModule          *tactical;
  PositionModule          *position;
  PositionEval            *poseval;
};





