//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup agents developed for the Simulator 
// League of the RoboCup 2001 competition
//
// Copyright (C) 1998, 1999, 2000, 2001 Team Members 
// of the Mainz Rolling Brains RoboCup Team 
//
// This program is published under the terms of the GNU General Public
// License as published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
//
// MRB player PositionEval
//
// \$Id: PositionEval.C,v 1.33 2002/06/11 16:22:20 fel Exp $
// \$manager: wachm$
//
//////////////////////////////////////////////////////////////////////

//#define POSFTRACE(output) Comm::sendMCmd(output)
//#define USEAREATRACE

#ifndef USEAREATRACE
#define AREATRC(output)
#else
#warning PositionEval AREATRACE aktiviert!!
#define FUNSSELMACROS
#include "drawMacros.h"
#define AREATRC(output) Comm::sendMCmd(output)
#endif

#ifndef POSFTRACE
#define POSFTRACE(output)
#else
#warning POSFTRACE aktiviert!!
#define FUNSSELMACROS
#include "drawMacros.h"
#define USEPOSLOG
#endif

#ifndef USEPOSLOG
#define POSLOG(output)
#else
#warning POSLOG aktiviert !!
#define POSLOG(output) { ostrstream ost;\
	ost << "POSLOG: " << output << (char)0;\
    char * str = ost.str(); \
 Comm::sendMCmd(MLog(str)); \
 delete str;}
#endif


#include "PositionEval.h"
#include "PositionFunctions.h"
#include "Config.h"


const double MAX_MINX_STEP=.17;
//max speed of our defense when going to other goal

//const double BALL_MIN_POSITION= 20;
const double BALL_MIN_POSITION= 35;
//how far our defenders try to stand behind the ball (relative)

const double MAX_AREA=FIELD_LENGTH/3.;
const double MIN_AREA=FIELD_LENGTH/6.;
//const double DIST_TO_OFFSIDE=2;
const double DIST_TO_OFFSIDE=.5;
const double MAX_OFFENDER_X_POS=FIELD_LENGTH/2-PENALTY_AREA_LENGTH/2;
const double MIN_DEFENDER_X_POS=-FIELD_LENGTH/2+0.75*PENALTY_AREA_LENGTH;

//constants to pull the offenders in the others penalty area and
const double OUR_PEN_AREA_STRETCH=.3;
const double FULL_OUR_PEN_AREA_STRETCH=-.5*FIELD_LENGTH+PENALTY_AREA_LENGTH-2;
const double START_OUR_PEN_AREA_STRETCH=FULL_OUR_PEN_AREA_STRETCH+3;

const double OTHER_PEN_AREA_STRETCH=.5;
const double FULL_OTHER_PEN_AREA_STRETCH=+.5*FIELD_LENGTH-PENALTY_AREA_LENGTH;
const double START_OTHER_PEN_AREA_STRETCH=FULL_OTHER_PEN_AREA_STRETCH-10;

//how far all players are pulled to the ball
const double NORMAL_BALL_FACTOR=.3;
const double OUR_PEN_BALL_FACTOR=.2;
const double OTHER_PEN_BALL_FACTOR=.3;

  //"WM Aufstellung"
PlayerPos Positions[2][10]={
  {
    //postion of the players
    //defensive
    // an x value that equals BALL_MIN_POSITION means x position of the ball, 
    // if we defend
    //2
    {Vector2d(0,FIELD_WIDTH*-1/4),
     0,1,Vector2d(0,FIELD_WIDTH*-1/2.),Vector2d(10,FIELD_WIDTH*0),
     {UNKNOWN,UNKNOWN,UNKNOWN}
    },
    //3
    {Vector2d(0,FIELD_WIDTH*0),
     0,1,Vector2d(0,FIELD_WIDTH*-1/4),Vector2d(10,FIELD_WIDTH*1/4),
     {UNKNOWN,UNKNOWN,UNKNOWN}
    },
    //4
    {Vector2d(0,FIELD_WIDTH*1/4),
     0,1,Vector2d(0,FIELD_WIDTH*-0),Vector2d(10,FIELD_WIDTH*1/2),
     {UNKNOWN,UNKNOWN,UNKNOWN}
    },
    //5
    {Vector2d(15,FIELD_WIDTH*-1/8),
     1,1,Vector2d(5,FIELD_WIDTH*-1/2),Vector2d(40,FIELD_WIDTH*1/8),
     {2,3,UNKNOWN}
    },
    //6
    {Vector2d(15,FIELD_WIDTH*1/8),
     1,1,Vector2d(5,FIELD_WIDTH*-1/8),Vector2d(40,FIELD_WIDTH*1/2),
    {4,3,UNKNOWN}
    },
    //7
    {Vector2d(50,FIELD_WIDTH*-3/16),
     1,1,Vector2d(20,FIELD_WIDTH*-1/2),Vector2d(70,FIELD_WIDTH*0),
    {UNKNOWN,UNKNOWN,UNKNOWN}
    },
    //8
    {Vector2d(50,FIELD_WIDTH*3/16),
     1,1,Vector2d(20,FIELD_WIDTH*-0),Vector2d(70,FIELD_WIDTH*1/2),
    {UNKNOWN,UNKNOWN,UNKNOWN}
    },
    //9
    {Vector2d(100,FIELD_WIDTH*-1/3),
     1,.7,Vector2d(60,FIELD_WIDTH*-1/2),Vector2d(100,FIELD_WIDTH*-1/10),
    {UNKNOWN,UNKNOWN,UNKNOWN}
    },
    //10
    {Vector2d(75,FIELD_WIDTH*0),
     1,.7,Vector2d(60,FIELD_WIDTH*-7/24.),Vector2d(100,FIELD_WIDTH*7/24.),
    {UNKNOWN,UNKNOWN,UNKNOWN}
    },
    //11
    {Vector2d(100,FIELD_WIDTH*1/3),
     1,.7,Vector2d(60,FIELD_WIDTH*1/10),Vector2d(100,FIELD_WIDTH*1/2),
     {UNKNOWN,UNKNOWN,UNKNOWN}
    }
  },
  {
    //postion of the players
    //offensive
    //2
    {Vector2d(0,FIELD_WIDTH*-1/4),
     0,1,Vector2d(0,FIELD_WIDTH*-1/2),Vector2d(20,FIELD_WIDTH*0),
     {UNKNOWN,UNKNOWN,UNKNOWN}
    },
    //3
    {Vector2d(0,FIELD_WIDTH*0),
     0,1,Vector2d(0,FIELD_WIDTH*-1/4),Vector2d(20,FIELD_WIDTH*1/4),
     {UNKNOWN,UNKNOWN,UNKNOWN}
    },
    //4
    {Vector2d(0,FIELD_WIDTH*1/4),
     0,1,Vector2d(0,FIELD_WIDTH*-0),Vector2d(20,FIELD_WIDTH*1/2),
    {UNKNOWN,UNKNOWN,UNKNOWN}
    },
    //5
    {Vector2d(30,FIELD_WIDTH*-1/8),
     1,1,Vector2d(10,FIELD_WIDTH*-1/2),Vector2d(50,FIELD_WIDTH*0),
     {2,3,UNKNOWN}
    },
    //6
    {Vector2d(30,FIELD_WIDTH*1/8),
     1,1,Vector2d(10,FIELD_WIDTH*0),Vector2d(50,FIELD_WIDTH*1/2),
    {4,3,UNKNOWN}
    },
    //7
    {Vector2d(70,FIELD_WIDTH*-3/16),
     1,.7,Vector2d(50,FIELD_WIDTH*-1/2),Vector2d(80,FIELD_WIDTH*0),
    {UNKNOWN,UNKNOWN,UNKNOWN}
    },
    //8
    {Vector2d(70,FIELD_WIDTH*3/16),
     1,.7,Vector2d(50,FIELD_WIDTH*-0),Vector2d(80,FIELD_WIDTH*1/2),
     {UNKNOWN,UNKNOWN,UNKNOWN}
    },
    //9
    {Vector2d(100,FIELD_WIDTH*-1/3),
     1,0.7,Vector2d(70,FIELD_WIDTH*-1/2),Vector2d(100,FIELD_WIDTH*-1/10),
     {UNKNOWN,UNKNOWN,UNKNOWN}
    },
    //10
    {Vector2d(100,FIELD_WIDTH*0),
     1,0.7,Vector2d(70,FIELD_WIDTH*-7/24.),Vector2d(100,FIELD_WIDTH*7/24.),
    {UNKNOWN,UNKNOWN,UNKNOWN}
    },
    //11
    {Vector2d(100,FIELD_WIDTH*1/3),
     1,0.7,Vector2d(70,FIELD_WIDTH*1/10),Vector2d(100,FIELD_WIDTH*1/2),
     {UNKNOWN,UNKNOWN,UNKNOWN}
    }
  } 
};

/*
//Viererkette
PlayerPos defenders[2][5]={{
  //postion of the left defender
  //defensive
			   {Vector2d(0,FIELD_WIDTH*-1/4),
			    1,1,1,0},
			   {Vector2d(0,FIELD_WIDTH*-1/8),
			    1,1,1,0},
			   {Vector2d(0,FIELD_WIDTH*1/8),
			    1,1,1,0},
			   {Vector2d(0,FIELD_WIDTH*1/4),
			    1,1,1,0},
			   {Vector2d(10,FIELD_WIDTH*0),
			    1,1,1,0}
			   },
			   {
			     //postion of the left defender
			     //offensive
			   {Vector2d(20,FIELD_WIDTH*-1/4),
			    1,1,1,0},
			   {Vector2d(0,FIELD_WIDTH*-1/8),
			    1,1,1,0},
			   {Vector2d(0,FIELD_WIDTH*1/8),
			    1,1,1,0},
			   {Vector2d(20,FIELD_WIDTH*1/4),
			    1,1,1,0},
			   {Vector2d(30,FIELD_WIDTH*0),
			    1,1,1,0}
			   }};

PlayerPos attackers[2][5]={{
			   //postion of the left
  //defensive
			   {Vector2d(60,FIELD_WIDTH*-1/3),
			    1,1,1,0},
			   {Vector2d(60,FIELD_WIDTH*1/3),
			    1,1,1,0},
			   {Vector2d(100,FIELD_WIDTH*-1/7),
			    1,1,1,0},
			   {Vector2d(100,FIELD_WIDTH*1/7),
			    1,1,1,0},
			   {Vector2d(40,FIELD_WIDTH*0),
			    1,1,1,0}
			   },
			   {//position of the left 	
			     //offensive
			   {Vector2d(90,FIELD_WIDTH*-1/3),
			    1,1,1,0},
			   {Vector2d(90,FIELD_WIDTH*1/3),
			    1,1,1,0},
			   {Vector2d(100,FIELD_WIDTH*-1/4),
			    1,1,1,0},
			   {Vector2d(100,FIELD_WIDTH*1/4),
			    1,1,1,0},
			   {Vector2d(80,FIELD_WIDTH*0),
			    1,1,1,0}
			   }};

*/

PositionEval::PositionEval(const GoalShotEval* _goalshoteval, 
			   const PassEval* _passeval)
  : goalshoteval(_goalshoteval), passeval(_passeval)
{
  int i;
  
  readAgent_conf();

  for (i=1;i<10;i++)
    RealPositions[i].Pos=Vector2d(0,0);

  minX=0;
  maxX=0;
}

PositionEval::~PositionEval()
{
}

Grade PositionEval::ourEval(const Snapshot* , int ) const
{
  returnGRADE(Grade());
}

	
Vector2d PositionEval::GetPlayerPosition(int PlayerNo) const 
{
  if ((PlayerNo>1) && (PlayerNo<12)) 
    return(RealPositions[PlayerNo-2].Pos);
  else return(Vector2d(0,0));
};

double PositionEval::GetMinX() const
{
  return(minX);
};
  
double PositionEval::GetMaxX() const
{
  return(maxX);
};

void PositionEval::CalMinMaxX(const Snapshot *wS) 
{
  if (time<wS->time)
    oldminX=minX;
  //save minX

  //Calculate the max. and min. positions of our players
  maxX=wS->ourOffsideLine(MAXAGE);
  maxX-=DIST_TO_OFFSIDE;
  POSFTRACE(VLINE(wS->ourOffsideLine(MAXAGE-2)));

  minX=min(wS->ball.pos.getX(),0.);
  minX=min(wS->ball.pos.getX()-BALL_MIN_POSITION*(maxX-minX)/100.,0.);
  minX=max(minX,MIN_DEFENDER_X_POS);
  //we don't want to stand too far in our own penalty area

  //We don't want to occupie a too small room 
  if (maxX-minX<MIN_AREA)
    minX=maxX-MIN_AREA;
  
  //and not a too big room
  if (maxX-minX>MAX_AREA)
     {
       if (0.5<offensive)
	   minX=maxX-MAX_AREA;
       else
	   maxX=minX+MAX_AREA;
    };
  
  //defenders shouldn't be in the others halfside
  if (minX>0)
    minX=0;
  //its not very useful if the offenders are too far in the others penalty
  //area
  if (maxX>MAX_OFFENDER_X_POS)
    maxX=MAX_OFFENDER_X_POS;

  if (oldminX+MAX_MINX_STEP<minX)
    {
      minX=oldminX+MAX_MINX_STEP;
      POSLOG("oldminX : "<< oldminX<<" minX : " <<minX<<" MAX_MINX_STEP: "<<
	     MAX_MINX_STEP);
    };

  //take care of the standartsituations
  switch (wS->playMode){
    /*
  case PLAY_MODE_CORNER_KICK_THEM:
    minX=FIELD_LENGTH/2;
    break;*/
  case PLAY_MODE_GOAL_THEM:
  case PLAY_MODE_GOAL_US:
    minX=-MIN_AREA;
    oldminX=-MIN_AREA;
    break;
  case PLAY_MODE_CORNER_KICK_US:
    maxX=FIELD_LENGTH/2+4-PENALTY_AREA_LENGTH;
    break;
  case PLAY_MODE_FREE_KICK_THEM:
    if (wS->ball.inOtherPenaltyArea())
      {
	maxX=FIELD_LENGTH/2-PENALTY_AREA_LENGTH-6;
	if (maxX-minX<MIN_AREA)
	  {
	    oldminX=minX=maxX-MIN_AREA;
	  };
      };
    break;
  case PLAY_MODE_FREE_KICK_US:
    if (wS->ball.inOurPenaltyArea())  
      {
	oldminX=minX=-(FIELD_LENGTH/2-PENALTY_AREA_LENGTH)+4;
	if (maxX-minX<MIN_AREA)
	  maxX=minX+MIN_AREA;
      };
    break;
  case PLAY_MODE_GOAL_KICK_US:
    {
      oldminX=minX=PENALTY_AREA_LENGTH-FIELD_LENGTH/2+4;
      if (maxX-minX<MIN_AREA)
	maxX=minX+MIN_AREA;
      break;
    };
  case PLAY_MODE_GOAL_KICK_THEM:
    {
      maxX=FIELD_LENGTH/2-PENALTY_AREA_LENGTH-6;
      if (maxX-minX<FIELD_LENGTH/4.)
	  oldminX=minX=maxX-FIELD_LENGTH/4.; 
    };
  default:
    break;
  };
  
  POSFTRACE(VLINE(minX));
  POSFTRACE(VLINE(maxX)); 
  
  offensive=Triangle(1.,minX-maxX,wS->ball.pos.getX()-maxX);
  defensive=Triangle(1.,maxX-minX,wS->ball.pos.getX()-minX);

  if (maxX<wS->ball.pos.getX()) 
    offensive=1;
  if (minX+BALL_MIN_POSITION*(maxX-minX)/100.>wS->ball.pos.getX())
    defensive=1;//ball behind defenders

  POSLOG("MaxX: " << maxX << "MinX: " << minX << " off.: " << offensive << 
	 " dev.: " << defensive);
  POSLOG("Ballpos " << wS->ball.pos); 

  time=wS->time;
};

	    
PlayerPos PositionEval::CalRealPos(PlayerPos DPos,PlayerPos OPos,
				   Vector2d BallPos) 
{
  PlayerPos Player;
  double ballx;
  double bally;

  Player.Pos=1/(offensive+defensive)*(offensive*OPos.Pos+defensive*DPos.Pos);
  
  //auf minX und maxX renormieren
  Player.Pos.setX(Player.Pos.getX()*(maxX-minX)/(100)+minX);
  
  //die Area anpassen
  Player.Min=1/(offensive+defensive)*(offensive*OPos.Min+defensive*DPos.Min);
  Player.Max=1/(offensive+defensive)*(offensive*OPos.Max+defensive*DPos.Max);
  Player.Min.setX(Player.Min.getX()*(maxX-minX)/100+minX);
  Player.Max.setX(Player.Max.getX()*(maxX-minX)/100+minX);

  ballx=(offensive*OPos.ballforceX+defensive*DPos.ballforceX)/
    (offensive+defensive);
  bally=(offensive*OPos.ballforceY+defensive*DPos.ballforceY)/
    (offensive+defensive);  

  //im den Strafrumen die Spieler etwas zusammenziehen, dafr aber
  //insgesammt mehr zum Ball gehen
  double OURstretch=Step(FULL_OUR_PEN_AREA_STRETCH,
			 START_OUR_PEN_AREA_STRETCH,
			 Player.Pos.getX());
  Player.Pos.setY((1-(OURstretch*OUR_PEN_AREA_STRETCH))*Player.Pos.getY());
  
  double OTHERstretch=1-Step(START_OTHER_PEN_AREA_STRETCH,
			     FULL_OTHER_PEN_AREA_STRETCH,
			     Player.Pos.getX());
  Player.Pos.setY((1-(OTHERstretch*OTHER_PEN_AREA_STRETCH))*Player.Pos.getY());

  double ballFactor=NORMAL_BALL_FACTOR+OURstretch*OUR_PEN_BALL_FACTOR+
    OTHERstretch*OTHER_PEN_BALL_FACTOR;

  POSLOG("OURstretch: " << OURstretch << "OTHERstretch: " << OTHERstretch
	 << " ballFactor: "<< ballFactor);
			     
  //den Raum um den Ball eng machen
  double BallDist=BallPos.getY()-Player.Pos.getY();
  /*      
  //lokal schnell zum Ball
  Pos.setX(Pos.getX()+
	   (.5*(BallPos.getX()-Pos.getX()))
	   *Triangle(ballx,FIELD_LENGTH/4,BallPos.getX()-Pos.getX())
	   *Triangle(ballx,FIELD_WIDTH*2./3,BallDist));
  
  Pos.setY(Pos.getY()+
	   (.5*BallDist)
	   *Triangle(bally,FIELD_LENGTH/4,BallPos.getX()-Pos.getX())
	   *Triangle(bally,FIELD_WIDTH*3./3,BallDist));
  
  //allgemein langsam zum Ball
  */  
  Player.Pos.setY(Player.Pos.getY()+(ballFactor*BallPos.getY())
	   *Triangle(bally,FIELD_LENGTH,BallPos.getX()-Player.Pos.getX())
	   *Triangle(bally,FIELD_WIDTH*2.5/3,BallDist));



  return(Player);
};


void PositionEval::CalPlayerPositions(const Snapshot *wS) 

{

  int j;

  //Calculate real positions
  for (j=0;j<10;j++)
    {
      RealPositions[j]=CalRealPos(Positions[0][j],Positions[1][j],
			 wS->ball.pos);

      POSFTRACE(CIRCLE(RealPositions[j].Pos,3));
    }

  POSFTRACE(LINE(GetPlayerPosition(wS->my.number),wS->my.pos));

#ifdef USEAREATRACE
  PlayerPos RealPos=RealPositions[wS->my.number-2];
  Vector2d tmp1=RealPos.Min;
  Vector2d tmp2=Vector2d(RealPos.Max.getX(),RealPos.Min.getY());
  AREATRC(LINE(tmp1,tmp2));
  tmp1=RealPos.Max;
  AREATRC(LINE(tmp1,tmp2));
  tmp2=Vector2d(RealPos.Min.getX(),RealPos.Max.getY());
  AREATRC(LINE(tmp1,tmp2));
  tmp1=RealPos.Min;
  AREATRC(LINE(tmp1,tmp2));
#endif
};

void PositionEval::GetPlayerArea(int PlayerNo, Vector2d &Min,
				 Vector2d &Max) const
{
  if ((PlayerNo>1) &&(PlayerNo<12))
    {
      Min=RealPositions[PlayerNo-2].Min;
      Max=RealPositions[PlayerNo-2].Max;
    }
  else 
    {
      Min=Vector2d(0,0);
      Max=Vector2d(0,0);
    }
};

bool PositionEval::IsInPlayerArea(int PlayerNo, Vector2d Pos) const
{
  Vector2d pMin;
  Vector2d pMax;
  GetPlayerArea(PlayerNo,pMin,pMax);
  return ((Pos.getX()<pMax.getX()) && (Pos.getX()>pMin.getX()) &&
	  (Pos.getY()<pMax.getY()) && (Pos.getY()>pMin.getY()));
};

int PositionEval::GetPlayerWatchNo(int PlayerNo, int WatchNo) const
{
  if ((PlayerNo>2) && (PlayerNo<11) && (WatchNo>=0) && (WatchNo<=2))
    return Positions[1][PlayerNo-2].Watches[WatchNo];
  else return UNKNOWN;
}

double PositionEval::GetOffensive() const
{
  return offensive;
};

void PositionEval::readAgent_conf(){
  char valueString[100];
  for (int i=0; i<10; i++){
    sprintf(valueString,"player%d_def_Pos",i+2);
    Positions[0][i].Pos = Config::getValueAsVector(valueString);
    Positions[0][i].Pos.setY(FIELD_WIDTH * Positions[0][i].Pos.getY());
 
    sprintf(valueString,"player%d_def_ballforceX",i+2);    
    Positions[0][i].ballforceX =Config::getValueAsDouble(valueString);
    
    sprintf(valueString,"player%d_def_ballforceY",i+2);
    Positions[0][i].ballforceY = Config::getValueAsDouble(valueString);
    
    sprintf(valueString,"player%d_def_Min",i+2);
    Positions[0][i].Min = Config::getValueAsVector(valueString);
    Positions[0][i].Min.setY(FIELD_WIDTH * Positions[0][i].Min.getY());
    
    sprintf(valueString,"player%d_def_Max",i+2);
    Positions[0][i].Max = Config::getValueAsVector(valueString);
    Positions[0][i].Max.setY(FIELD_WIDTH * Positions[0][i].Max.getY());
    
    for (int j=0;j<3;j++){
      sprintf(valueString,"player%d_def_Watches_%d",i+2,j+1);
      Positions[0][i].Watches[j] = Config::getValueAsInt(valueString);
      } 
  
    sprintf(valueString,"player%d_off_Pos",i+2);
    Positions[1][i].Pos = Config::getValueAsVector(valueString);
    Positions[1][i].Pos.setY(FIELD_WIDTH * Positions[1][i].Pos.getY());
 
    sprintf(valueString,"player%d_off_ballforceX",i+2);    
    Positions[1][i].ballforceX =Config::getValueAsDouble(valueString);
    
    sprintf(valueString,"player%d_off_ballforceY",i+2);
    Positions[1][i].ballforceY = Config::getValueAsDouble(valueString);
    
    sprintf(valueString,"player%d_off_Min",i+2);
    Positions[1][i].Min = Config::getValueAsVector(valueString);
    Positions[1][i].Min.setY(FIELD_WIDTH * Positions[1][i].Min.getY());
    
    sprintf(valueString,"player%d_off_Max",i+2);
    Positions[1][i].Max = Config::getValueAsVector(valueString);
    Positions[1][i].Max.setY(FIELD_WIDTH * Positions[1][i].Max.getY());
    
    for (int j=0;j<3;j++){
      sprintf(valueString,"player%d_off_Watches_%d",i+2,j+1);
      Positions[1][i].Watches[j] = Config::getValueAsInt(valueString);
    }
  }
}

